class ADTString {
    int size = 0
    String content
    ADTString() { // Constructor
        content = ""
    }
    int length() {
        return size
    }
    String character(int n) {
        assert length()>0, "ADT String ist leer"
        assert n < length(), "Ungltige Angabe"
        assert n >= 0, "Ungltige Angabe"
        return content[n]
    }
    void append(String n) {
        content += n
        size++
    }
    static ADTString add(ADTString a, ADTString b) {
        ADTString ret = new ADTString()
        for (int now=0; now<a.length(); now++) {
            ret.append(a.character(now))
        }
        for (int now=0; now<b.length(); now++) {
            ret.append(b.character(now))
        }
        return ret
    }
    ADTString substring(int from, int to) {
        ADTString ret = new ADTString()
        for (int now=from; now<to; now++) {
            ret.append(character(now))
        }
        return ret
    }
}

def a = new ADTString()

assert a.content=='', "Nicht leer"
assert a.length()==0, "Nicht leer"

a.append('a')

assert a.content=='a', "a nicht enthalten"
assert a.length()==1, "a nicht enthalten"

a.append('b')
a.append('c')
def b = new ADTString()
b.append('c')
b.append('b')
b.append('a')

def c = ADTString.add(a,b)

assert c.content=='abccba', "add geht nicht"

assert c.substring(0,4).content=='abcc', "substring geht nicht"

println "Alles Ok"