package Aufgaben.A03

import Aufgaben.SNodePosition
import Aufgaben.SNode
import Aufgaben.ADTSNodeListe

// now follows some magic ... see Objective-C Categories
// or Groovy Categories ... otherwise just ignore it ;-)
class ADTListeErweiterung {
    static ADTSNodeListe insertList(ADTSNodeListe orig, ADTSNodeListe add, SNodePosition pos) { // O(n)
        //println orig.elements()
        //println add.elements()
        //println orig.retrieve(pos)
        SNodePosition addPos = add.first() // O(1)
        while (addPos!=SNodePosition.NULL) { // O(n)
            orig.insert(add.retrieve(addPos),pos) // O(1)
            pos=orig.next(pos) // O(1)
            addPos=add.next(addPos) // O(1)
        }
        return orig
    }
}
// ------------------------ read on :)

// new list 
def l = new ADTSNodeListe()
(10..1).each({ k -> l.insert(k,SNodePosition.NULL)})
assert 10==l.size(), "Lenge nicht korrekt"
assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]==l.elements(), "Inhalt nicht korrekt"
assert 10==l.retrieve(l.end()), "end() nicht korrekt"
assert 1==l.retrieve(l.first()), "first() nicht korrekt"
assert 1==l.retrieve(l.first()), "retrieve() nicht korrekt"
assert 2==l.retrieve(l.next(l.first())), "next() nicht korrekt"

def m = new ADTSNodeListe()
(20..11).each({ k -> m.insert(k,SNodePosition.NULL)})
assert [11, 12, 13, 14, 15, 16, 17, 18, 19, 20]==m.elements(), "Inhalt nicht korrekt"

use (ADTListeErweiterung) {
    // now insertList method is available to us
    assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20]==l.insertList(m,l.end()).elements(), "insertList funktioniert nicht"
}

println "Alles Ok"