package Aufgaben.A03

import Aufgaben.ADTStack
import Aufgaben.ADTQueue

// a
// b
// beide nicht sinnvoll lsbar imho

// c
class TwoStackQueue extends ADTQueue {
    ADTStack one
    ADTStack two
    TwoStackQueue() {
        one = new ADTStack()
        two = new ADTStack()
    }
    def resort(ADTStack a, ADTStack b) { // from a to b
        while (!a.empty()) { // O(n)
            b.push(a.pop())  // O(1)
        }
    }
    boolean empty() { // O(1)
        return one.empty() && two.empty()
    }
    def front() { // O(n)
        if (empty()) { // O(1)
            println "Kein erstes Element, Queue ist leer"
            return null
        }
        if (two.empty()) { // O(n) bei n?tigem resort
            resort(one,two) // O(n)
        }
        return two.top()
    }
    def enqueue(Object o) { // O(n)
        if (one.empty()) // O(n) bei n?tigem resort
            resort(two,one)
        one.push(o) // O(1)
    }
    Object dequeue() {
        if (empty()) { // O(1)
            println "Kein erstes Element, Queue ist leer"
            return null
        }
        if (two.empty()) // O(n) bei n?tigem resort
            resort(one,two)
        return two.pop()
    }
}

def sq = new TwoStackQueue()
assert sq.empty(), "Objekt nicht leer"
(1..10).each {sq.enqueue(it)}
assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]==sq.one.elements[0..9], "Elemente in One nicht korrekt"
assert [null, null, null, null, null, null, null, null, null, null]==sq.two.elements[0..9], "Elemente in Two nicht korrekt"
//println sq.one.elements
//println sq.two.elements
5.times { sq.dequeue() }
assert [null, null, null, null, null, null, null, null, null, null]==sq.one.elements[0..9], "Elemente in One nicht korrekt"
assert [10, 9, 8, 7, 6, null, null, null, null, null]==sq.two.elements[0..9], "Elemente in Two nicht korrekt"
//println sq.one.elements
//println sq.two.elements

// -------------------

// d
class TwoQueueStack extends ADTStack {
    ADTQueue one
    ADTQueue two
    TwoQueueStack() {
        one = new ADTQueue() // used to top,pop / dequeue
        two = new ADTQueue() // used to push / enqueue
    }
    def resort(ADTQueue a, ADTQueue b) { // from a to b ... O(n^2)
        while (!a.empty()) { // O(n)
            b.enqueue(a.dequeue())  // O(n)
        }
    }
    boolean empty() { // O(1)
        return one.empty() && two.empty()
    }
    def push(Object o) { // O(n)
       if (two.empty()) // O(n) bei n?tigem resort
            resort(one,two) 
        two.enqueue(o) // O(1)
    }
    def top() { // O(n)
        if (one.empty()) // O(n) bei n?tigem resort
            resort(two,one) 
        return one.first() // O(1)
    }
    def pop() { // O(2n) => O(n)
        if (one.empty()) // O(n) bei n?tigem resort
            resort(two,one) 
        return one.dequeue() // O(n)
    }
}

def qs = new TwoQueueStack()
assert qs.empty(), "Objekt nicht leer"
(1..10).each {qs.push(it)}
assert [null, null, null, null, null, null, null, null, null, null]==qs.one.elements[0..9], "Elemente in One nicht korrekt"
assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]==qs.two.elements[0..9], "Elemente in Two nicht korrekt"
5.times { qs.pop() }
assert [null, null, null, null, null, null, null, null, null, null]==sq.one.elements[0..9], "Elemente in One nicht korrekt"
assert [10, 9, 8, 7, 6, null, null, null, null, null]==sq.two.elements[0..9], "Elemente in Two nicht korrekt"
//println sq.one.elements
//println sq.two.elements

println "Alles Ok"