package Aufgaben;

class ADTBinTree {
    private Object info // content
    private ADTBinTree left
    private ADTBinTree right
    private ADTBinTree parent
    ADTBinTree(Object nInfo) {
        info = nInfo
        left = null
        right = null
        parent = null
    }
    def setLeft(ADTBinTree t) {
        t.parent = this
        left = t
    }
    def setRight(ADTBinTree t) {
        t.parent = this
        right = t
    }
    def hasChildren() {
        return left!=null || right!=null
    }
    def isLeaf() {
        return !hasChildren()
    }
    def isRoot() {
        return parent==null
    }
    def height() {
        if (isLeaf())
            return 0
        return left?.height() > right?.height() ? left.height()+1 : right.height()+1
    }
    static main(String[] args) {
        def root = new ADTBinTree(1)
        assert root.info==1, "Info wird nicht korrekt gespeichert"
        assert root.height()==0, "Hhe wird nicht korrekt gespeichert"
        assert root.isRoot(), "Wurzel wird nicht korrekt gespeichert"
        def two = new ADTBinTree(2)
        root.left = two
        assert !two.isRoot(), "Wurzel wird nicht korrekt gespeichert"
        assert two.parent.isRoot(), "Parent wird nicht korrekt referenziert"
        assert root.height()==1, "Hhe wird nicht korrekt gendert"
        def three = new ADTBinTree(3)
        two.left = three
        def four = new ADTBinTree(4)
        two.right = four
        println "Everything Ok"
    }
}